#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}require("loud-rejection/register");var TS=_interopDefault(require("trie-search")),RenderKid=_interopDefault(require("renderkid")),prettyJson=_interopDefault(require("jsome")),chalk=require("chalk"),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),has=_interopDefault(require("lodash.has")),every=_interopDefault(require("lodash.every")),partial=_interopDefault(require("lodash.partial")),cpx=_interopDefault(require("cpx")),rimraf=_interopDefault(require("rimraf")),pick=_interopDefault(require("lodash.pick")),jsonFile=_interopDefault(require("jsonfile")),rollup=require("rollup"),util=require("util"),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),executable=_interopDefault(require("rollup-plugin-executable")),asyncToGenerator=function(e){return function(){var r=e.apply(this,arguments);return new Promise(function(e,t){function n(i,a){try{var o=r[i](a),l=o.value}catch(e){return void t(e)}if(!o.done)return Promise.resolve(l).then(function(e){n("next",e)},function(e){n("throw",e)});e(l)}return n("next")})}},_extends=Object.assign||function(e){for(var r=1;r<arguments.length;r++){var t=arguments[r];for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])}return e},createSearcher=({commands:e=[]}={})=>{const r=e.map(e=>{const r=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...r].join(" ")})}),t=new TS(["tokens"]);return t.addAll(r),t};const isPromise=e=>!!e&&("object"==typeof e||"function"==typeof e)&&"function"==typeof e.then;var createExecutor=({defaultStyle:e,defaultRenderer:r=console.log})=>t=>(...n)=>{const i=t.run(...n),a=t.renderer||r,o=new RenderKid;if(o.style(e),isPromise(i))return i.then(e=>t.template?o.render(t.template(e)):e).then(a);return a(t.template?o.render(t.template(i)):i)};const configureKli=({defaultStyle:e,defaultRenderer:r=console.log}={})=>({commands:t=[]}={})=>{if(!Array.isArray(t))throw new Error("Commands must be an array");if(0===t.length)throw new Error("No commands defined");if(t.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")}),1===t.length)return{execute:()=>t[0].run()};const n=createSearcher({commands:t}),i=createExecutor({defaultStyle:e,defaultRenderer:r});return{execute:e=>{const r=n.get(e[0])[0];return i(r)()}}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}},packageListTemplate=e=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,checkedPackagesTemplate=e=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e.packages).map(([e,r])=>`<item>\n                <title>${e}</title>\n                ${Object.entries(r).filter(([e])=>"publishable"!==e).map(([e,r])=>r?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(r).reduce((e,r)=>e.length>r.length?e:r,0).length+3).join("─")}</check>\n                <check>${r.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    <bar>-</bar>\n    <title>Repository</title>\n    ${Object.entries(e.root).map(([e,r])=>r?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n    `;const glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>r=>match(e,r);var findPackages=({root:e=".",exclude:r=[]}={})=>new Promise((()=>{var t=asyncToGenerator(function*(t,n){try{const i=path.resolve(e,"src/node_modules");if(!(yield lstat(i)).isDirectory)return n("NO");const a=path.resolve(i,"**/package.json");return t((yield glob(a)).filter(function(e){return!r.some(have(e))}).map(function(r){const t=require(r);return{dir:path.relative(e,path.dirname(r)),name:t.name,bin:t.bin,main:t.main,config:t}}).filter(function(e){return e.name}))}catch(e){return n(e)}});return function(e,r){return t.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),list=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).then(transmute.isolate("packages"));const lstat$2=promisify(fs.lstat);var checkPackage=(()=>{var e=asyncToGenerator(function*(e={},r="."){const t={};t["has package name"]=!!e.name;try{const n=path.resolve(r,e.dir,"readme.md"),i=yield lstat$2(n);t["has readme file"]=!!i.isFile}catch(e){t["has readme file"]=!1}try{if(e.main||!e.bin){const n=path.resolve(r,e.dir,e.main||"index.js"),i=yield lstat$2(n);t["has main and/or all bin files"]=!!i.isFile}if(e.bin){const n=Object.values(e.bin),i=yield Promise.all(n.map(function(t){return path.resolve(r,e.dir,t)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$2(e)});return function(r){return e.apply(this,arguments)}})()));t["has main and/or all bin files"]=!i.some(function(e){return!e.isFile})}}catch(e){t["has main and/or all bin files"]=!1}return Object.values(t).some(function(e){return!e})?{[e.name]:_extends({},t,{publishable:!1})}:{[e.name]:_extends({},t,{publishable:!0})}});return function(){return e.apply(this,arguments)}})();const lstat$1=promisify(fs.lstat);var publishCheck=({root:e,baseConfig:r={},packages:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n){if(0===t.length)return n([]);const i=yield Promise.all(t.map(function(r){return checkPackage(r,e)})),a={};try{const r=path.resolve(e,"LICENSE"),t=yield lstat$1(r);a["has root license"]=!!t.isFile}catch(e){a["has root license"]=!1}return a["has required package.json fields"]=every(["description","homepage","author","repository","bugs","license","dependencies"],function(e){return partial(has,e)}(r)),n({root:a,packages:i.reduce(function(e,r){if(r.undefined){const t=e.undefined?[...e.undefined,r.undefined]:[r.undefined];return _extends({},e,{undefined:t})}return Object.assign(e,r)},{})})});return function(e){return n.apply(this,arguments)}})()),findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),check=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("checks",publishCheck).then(transmute.isolate("checks"));const removeDir=util.promisify(rimraf),copy=util.promisify(cpx.copy),writeJson=util.promisify(jsonFile.writeFile),requiredProps=["version","description","homepage","author","repository","bugs","license","dependencies"];var buildPackages=({root:e,baseConfig:r,configs:t=[]}={})=>removeDir(path.resolve(e,"dist")).then(()=>Promise.all(t.map(t=>rollup.rollup({input:t.input,external:t.external,plugins:t.plugins}).then(e=>Promise.all(t.output.map(r=>e.write({file:r.file,format:r.format,banner:t.banner})))).then(()=>Promise.all([copy(path.resolve(e,"LICENSE"),path.resolve(t.destDir),{dereference:!0}),copy(path.resolve(t.srcDir,"readme.md"),path.resolve(t.destDir),{dereference:!0}),writeJson(path.resolve(t.destDir,"package.json"),_extends({},t.packageConfig,pick(r,requiredProps)),{spaces:4})])))));const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]};var buildRollupConfigs=({root:e=".",packages:r=[],baseConfig:t={dependencies:{}}}={})=>new Promise(n=>n([].concat(...r.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(r=>Object.values(r.bin).map(n=>({name:r.name,srcDir:path.resolve(e,"src/node_modules",r.name),destDir:path.resolve(e,"dist",r.name),packageConfig:r.config,input:path.resolve(e,"src/node_modules",r.name,n),external:[...Object.keys(t.dependencies),"fs","path","util"],output:[{file:path.resolve(e,"dist",r.name,n),format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[nodeResolve({customResolveOptions:{moduleDirectory:"src/node_modules"},preferBuiltins:!0}),babel(babelConfig),uglify({},uglifyEs.minify),executable(),filesize()]})))))),build=()=>transmute__default({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("unfiltered",findPackages).extend("packages",({unfiltered:e})=>e.filter(e=>e.bin)).extend("configs",buildRollupConfigs).then(buildPackages);const kli=configure({defaultStyle:style}),cli=kli({commands:[{name:"list",aliases:["ls"],template:packageListTemplate,run:list},{name:"check",template:checkedPackagesTemplate,run:check},{name:"build",renderer:()=>{},run:build}]});cli.execute(process.argv.slice(2));
